% Author:   Yimin Xiao
% Date: 09/11/2011
% Project: Audio Signal Generating and Processing Project
%          This script creates a sound bank that consists musical notes  
%          from A1 to a1, consisting three whole intervals.
%          Then the script plays first two lines of Parable's piece Canon, 
%          in an very inefficient way of typing equations.



clc
clear



samplerate = 8000;
n = 1:8000;
num_of_sounds = 3;

decrease_cosntant = 0.000259930193;
decrease_8000 = exp(n*-0.000173286795);
decrease_6000 = exp(n(1:6000)*-0.000173286795);
decrease_4000 = exp(n(1:4000)*-0.000173286795);
decrease_2000 = exp(n(1:2000)*-0.000173286795);
decrease_1000 = exp(n(1:1000)*-0.000173286795);

output_vector(8000*20) = 0;

Note_A1  = cos(440*(2^(-12/12))/samplerate*2*pi.*n);
Note_bB1 = cos(440*(2^(-11/12))/samplerate*2*pi.*n);
Note_B1  = cos(440*(2^(-10/12))/samplerate*2*pi.*n);
Note_C  = cos(440*(2^(-9/12))/samplerate*2*pi.*n);
Note_bD = cos(440*(2^(-8/12))/samplerate*2*pi.*n);
Note_D  = cos(440*(2^(-7/12))/samplerate*2*pi.*n);
Note_bE = cos(440*(2^(-6/12))/samplerate*2*pi.*n);
Note_E  = cos(440*(2^(-5/12))/samplerate*2*pi.*n);
Note_F  = cos(440*(2^(-4/12))/samplerate*2*pi.*n);
Note_bG = cos(440*(2^(-3/12))/samplerate*2*pi.*n);
Note_G  = cos(440*(2^(-2/12))/samplerate*2*pi.*n);
Note_bA = cos(440*(2^(-1/12))/samplerate*2*pi.*n);
Note_A  = cos(440/samplerate*2*pi.*n);
Note_bB = cos(440*(2^(1/12))/samplerate*2*pi.*n);
Note_B  = cos(440*(2^(2/12))/samplerate*2*pi.*n);
Note_c  = cos(440*(2^(3/12))/samplerate*2*pi.*n);
Note_bd = cos(440*(2^(4/12))/samplerate*2*pi.*n);
Note_d  = cos(440*(2^(5/12))/samplerate*2*pi.*n);
Note_be = cos(440*(2^(6/12))/samplerate*2*pi.*n);
Note_e  = cos(440*(2^(7/12))/samplerate*2*pi.*n);
Note_f  = cos(440*(2^(8/12))/samplerate*2*pi.*n);
Note_bg = cos(440*(2^(9/12))/samplerate*2*pi.*n);
Note_g  = cos(440*(2^(10/12))/samplerate*2*pi.*n);
Note_ba = cos(440*(2^(11/12))/samplerate*2*pi.*n);
Note_a  = cos(440*(2^(12/12))/samplerate*2*pi.*n);
Note_bb = cos(440*(2^(13/12))/samplerate*2*pi.*n);
Note_b  = cos(440*(2^(14/12))/samplerate*2*pi.*n);
Note_c1 = cos(440*(2^(15/12))/samplerate*2*pi.*n);
Note_bd1  = cos(440*(2^(16/12))/samplerate*2*pi.*n);
Note_d1   = cos(440*(2^(17/12))/samplerate*2*pi.*n);
Note_be1  = cos(440*(2^(18/12))/samplerate*2*pi.*n);
Note_e1   = cos(440*(2^(19/12))/samplerate*2*pi.*n);
Note_f1   = cos(440*(2^(20/12))/samplerate*2*pi.*n);
Note_bg1  = cos(440*(2^(21/12))/samplerate*2*pi.*n);
Note_g1   = cos(440*(2^(22/12))/samplerate*2*pi.*n);
Note_ba1  = cos(440*(2^(23/12))/samplerate*2*pi.*n);
Note_a1   = cos(440*(2^(24/12))/samplerate*2*pi.*n);

%   First Phase
output_vector(8000*0+1:8000*1) = (0.1 *Note_C + 0.1*Note_G + 0.1*Note_c + 0.1 *Note_e1).*decrease_8000;
output_vector(8000*1+1:8000*2) = (0.1 *Note_D + 0.1*Note_G + 0.1*Note_B + 0.1 *Note_d1).*decrease_8000;
output_vector(8000*2+1:8000*3) = (0.1 *Note_C + 0.1*Note_E + 0.1*Note_A + 0.1 *Note_c1).*decrease_8000;
output_vector(8000*3+1:8000*4) = (0.1 *Note_B1 + 0.1*Note_E + 0.1*Note_G + 0.1 *Note_b).*decrease_8000;
output_vector(8000*4+1:8000*5) = (0.1 *Note_C + 0.1*Note_F + 0.1*Note_A + 0.1 *Note_a).*decrease_8000;
output_vector(8000*5+1:8000*6) = (0.1 *Note_C + 0.1*Note_G + 0.1*Note_c + 0.1 *Note_g).*decrease_8000;
output_vector(8000*6+1:8000*7) = (0.1 *Note_C + 0.1*Note_F + 0.1*Note_A + 0.1 *Note_a).*decrease_8000;
output_vector(8000*7+1:8000*8) = (0.1 *Note_G + 0.1*Note_d + 0.1*Note_g + 0.1 *Note_b).*decrease_8000;
%   Second Phase
output_vector(8000*8+1:8000*8+6000)   = (0.1 *Note_C(1:6000) + 0.1*Note_G(1:6000) + 0.1*Note_c(1:6000) + 0.1 *Note_e1(1:6000)).*decrease_6000;
output_vector(8000*8+6000+1:8000*8+7000)   = (0.1 *Note_C(1:1000) + 0.1*Note_G(1:1000) + 0.1*Note_c(1:1000) + 0.1 *Note_f1(1:1000)).*decrease_1000;
output_vector(8000*8+7000+1:8000*9)   = (0.1 *Note_C(1:1000) + 0.1*Note_G(1:1000) + 0.1*Note_c(1:1000) + 0.1 *Note_e1(1:1000)).*decrease_1000;
output_vector(8000*9+1:8000*10)  = (0.1 *Note_D + 0.1*Note_G + 0.1*Note_B + 0.1 *Note_d1).*decrease_8000;
output_vector(8000*10+1:8000*10+6000) = (0.1 *Note_C(1:6000) + 0.1*Note_E(1:6000) + 0.1*Note_A(1:6000) + 0.1 *Note_c1(1:6000)).*decrease_6000;
output_vector(8000*10+6000+1:8000*10+7000) = (0.1 *Note_C(1:1000) + 0.1*Note_E(1:1000) + 0.1*Note_A(1:1000) + 0.1 *Note_d1(1:1000)).*decrease_1000;
output_vector(8000*10+7000+1:8000*11) = (0.1 *Note_C(1:1000) + 0.1*Note_E(1:1000) + 0.1*Note_A(1:1000) + 0.1 *Note_c1(1:1000)).*decrease_1000;
output_vector(8000*11+1:8000*11+2000) = (0.1 *Note_E(1:2000) + 0.1*Note_G(1:2000) + 0.1*Note_B(1:2000) + 0.1 *Note_b(1:2000)).*decrease_2000;
output_vector(8000*11+2000+1:8000*11+4000) = (0.1 *Note_E(1:2000) + 0.1*Note_G(1:2000) + 0.1*Note_B(1:2000) + 0.1 *Note_e1(1:2000)).*decrease_2000;
output_vector(8000*11+4000+1:8000*11+6000) = (0.1 *Note_E(1:2000) + 0.1*Note_G(1:2000) + 0.1*Note_B(1:2000) + 0.1 *Note_g1(1:2000)).*decrease_2000;
output_vector(8000*11+6000+1:8000*12) = (0.1 *Note_E(1:2000) + 0.1*Note_G(1:2000) + 0.1*Note_B(1:2000) + 0.1 *Note_a1(1:2000)).*decrease_2000;
output_vector(8000*12+1:8000*12+2000)      = (0.1 *Note_C(1:2000) + 0.1*Note_F(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_f1(1:2000)).*decrease_2000;
output_vector(8000*12+2000+1:8000*12+4000) = (0.1 *Note_C(1:2000) + 0.1*Note_F(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_e1(1:2000)).*decrease_2000;
output_vector(8000*12+4000+1:8000*12+6000) = (0.1 *Note_C(1:2000) + 0.1*Note_F(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_d1(1:2000)).*decrease_2000;
output_vector(8000*12+6000+1:8000*13)      = (0.1 *Note_C(1:2000) + 0.1*Note_F(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_f1(1:2000)).*decrease_2000;
output_vector(8000*13+1:8000*13+2000)      = (0.1 *Note_C(1:2000) + 0.1*Note_G(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_e1(1:2000)).*decrease_2000;
output_vector(8000*13+2000+1:8000*13+4000) = (0.1 *Note_C(1:2000) + 0.1*Note_G(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_d1(1:2000)).*decrease_2000;
output_vector(8000*13+4000+1:8000*13+6000) = (0.1 *Note_C(1:2000) + 0.1*Note_G(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_c1(1:2000)).*decrease_2000;
output_vector(8000*13+6000+1:8000*14)      = (0.1 *Note_C(1:2000) + 0.1*Note_G(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_b(1:2000)).*decrease_2000;
output_vector(8000*14+1:8000*14+2000)      = (0.1 *Note_C(1:2000) + 0.1*Note_F(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_a(1:2000)).*decrease_2000;
output_vector(8000*14+2000+1:8000*14+4000) = (0.1 *Note_C(1:2000) + 0.1*Note_F(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_g(1:2000)).*decrease_2000;
output_vector(8000*14+4000+1:8000*14+6000) = (0.1 *Note_C(1:2000) + 0.1*Note_F(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_f(1:2000)).*decrease_2000;
output_vector(8000*14+6000+1:8000*15)      = (0.1 *Note_C(1:2000) + 0.1*Note_F(1:2000) + 0.1*Note_c(1:2000) + 0.1 *Note_c1(1:2000)).*decrease_2000;
output_vector(8000*15+1:8000*16) = (0.1 *Note_G + 0.1*Note_d + 0.1*Note_g + 0.1 *Note_b).*decrease_8000;
% Ending Tone
output_vector(8000*16+1:8000*17) = (0.1 *Note_C + 0.1*Note_E + 0.1*Note_G + 0.1 *Note_c).*decrease_8000;


sound(output_vector,samplerate);